searchNodes=[{"doc":"Helpers for defining (bootstrapped, semi-)principled type classes Generates a few modules and several functions and aliases. There is no need to use these internals directly, as the top-level API will suffice for actual productive use. Example defclass Semigroup do use Operator where do @operator :&lt;|&gt; def concat ( a , b ) end properties do def associative ( data ) do a = generate ( data ) b = generate ( data ) c = generate ( data ) left = a |&gt; Semigroup . concat ( b ) |&gt; Semigroup . concat ( c ) right = Semigroup . concat ( a , Semigroup . concat ( b , c ) ) left == right end end end definst Semigroup , for : List do def concat ( a , b ) , do : a ++ b end defclass Monoid do extend Semigroup where do def empty ( sample ) end properties do def left_identity ( data ) do a = generate ( data ) Semigroup . concat ( empty ( a ) , a ) == a end def right_identity ( data ) do a = generate ( data ) Semigroup . concat ( a , empty ( a ) ) == a end end end definst Monoid , for : List do def empty ( _ ) , do : [ ] end Internal Structure A type_class is composed of several parts: Dependencies Protocol Properties Dependencies Dependencies are the other type classes that the type class being defined extends. For instance, Monoid has a Semigroup dependency. It only needs the immediate parents in the chain, as those type classes will have performed all of the checks required for their parents. Protocol defclass Foo generates a Foo.Proto submodule that holds all of the functions to be implemented (it's a normal protocol). It's a very lightweight &amp; straightforward, but The Protocol should never need to be called explicitly. Macro: where do Optional Properties Being a (quasi-)principled type class also means having properties. Users must define at least one property, plus at least one sample data generator. These will be run at compile time and refuse to compile if they don't pass. All custom structs need to implement the TypeClass.Property.Generator protocol. This is called automatically by the prop checker. Base types have been implemented by this library. Please note that class functions are aliased to the last segment of their name. ex. Foo.Bar.MyClass.quux is automatically usable as MyClass.quux in the proprties block Macro: properties do Non-optional","ref":"TypeClass.html","title":"TypeClass","type":"module"},{"doc":"Variant of conforms/2 that can be called within a data module","ref":"TypeClass.html#conforms/1","title":"TypeClass.conforms/1","type":"macro"},{"doc":"Check that a datatype conforms to the class hierarchy and properties","ref":"TypeClass.html#conforms/2","title":"TypeClass.conforms/2","type":"macro"},{"doc":"Delegate to a local function","ref":"TypeClass.html#defalias/2","title":"TypeClass.defalias/2","type":"macro"},{"doc":"Top-level wrapper for all type class modules. Used as a replacement for defmodule . Examples defclass Semigroup do # @force_type_class true where do def concat ( a , b ) end properties do def associative ( data ) do a = generate ( data ) b = generate ( data ) c = generate ( data ) left = a |&gt; Semigroup . concat ( b ) |&gt; Semigroup . concat ( c ) right = Semigroup . concat ( a , Semigroup . concat ( b , c ) ) left == right end end end See @force_type_class section in the README for more.","ref":"TypeClass.html#defclass/2","title":"TypeClass.defclass/2","type":"macro"},{"doc":"Convenience alises for definst/3 1. Implicit :for Shortcut for definst ATypeClass , for : __MODULE__ do # required function definitions end when implementing type class instances inside the module where the data type is defined. Examples defmodule Name do import Algae import TypeClass use Witchcraft defdata do name :: String . t ( ) end definst Witchcraft.Functor do @force_type_instance true def map ( %{ name : name } , f ) , do : %{ name : f . ( name ) } # def map(_, _), do: 27 # %{name: f.(name)} end def add_title ( % __MODULE__ { } = name , title ) do name ~&gt; &amp; Kernel . &lt;&gt; ( title , &amp;1 ) end end iex(3)&gt; name = X . new ( &quot;Kilgore Troutman&quot; ) % X { name : &quot;Kilgore Troutman&quot; } iex(4)&gt; X . add_title ( name , &quot;Dr. &quot; ) %{ name : &quot;Dr. Kilgore Troutman&quot; } NOTE: copy-pasting the above in IEx won't work because definst checks properties at compile time. 2. No body When you only want to check the properties (ex. when there is no where block, such as in Witchcraft.Monad ). Examples # Dependency defclass Base do where do def plus_one ( a ) end properties do def pass ( _ ) , do : true end end # No `where` defclass MoreProps do extend Base properties do def yep ( a ) , do : equal? ( a , a ) end end definst Base , for : Integer do def plus_one ( a ) , do : a + 5 end definst MoreProps , for : Integer","ref":"TypeClass.html#definst/2","title":"TypeClass.definst/2","type":"macro"},{"doc":"Define an instance of the type class. The rough equivalent of defimpl . definst will check the properties at compile time, and prevent compilation if the datatype does not conform to the protocol. Examples definst Semigroup , for : List do # @force_type_instance true def concat ( a , b ) , do : a ++ b end See @force_type_instance section in the README for more. __MODULE__ 's meaning changes inside definst Beware that the value of __MODULE__ inside definst will be different from the outside context: definst 's do block will be invoked inside defimpl macro's body, and defimpl creates its own container module to run things in. For example, the code below won't compile: defmodule Name do import Algae import TypeClass use Witchcraft defdata do name :: String . t ( ) end definst Witchcraft.Functor , for : __MODULE__ do @force_type_instance true def map ( % __MODULE__ { name : name } , f ) do __MODULE__ . new ( name ) end end end # ** (CompileError) lib/instance/assword.ex:13: # Witchcraft.Functor.Proto.Instance.Name.__struct__/0 is undefined, # cannot expand struct Witchcraft.Functor.Proto.Instance.Name Either use the full module name, or alias it, if too long, such as defmodule Name do # (...) # here definst Witchcraft.Functor , for : __MODULE__ do # or here # (...) end end","ref":"TypeClass.html#definst/3","title":"TypeClass.definst/3","type":"macro"},{"doc":"Define properties that any instance of the type class must satisfy. They must by unary (takes a data seed), and return a boolean (true if passes). generate is automatically imported Examples defclass Semigroup do # ... properties do def associative ( data ) do a = generate ( data ) b = generate ( data ) c = generate ( data ) left = a |&gt; Semigroup . concat ( b ) |&gt; Semigroup . concat ( c ) right = Semigroup . concat ( a , Semigroup . concat ( b , c ) ) left == right end end end","ref":"TypeClass.html#properties/1","title":"TypeClass.properties/1","type":"macro"},{"doc":"","ref":"TypeClass.html#run_where!/0","title":"TypeClass.run_where!/0","type":"macro"},{"doc":"Describe functions to be instantiated. Creates an internal protocol. Examples defclass Semigroup do where do def concat ( a , b ) end # ... end","ref":"TypeClass.html#where/1","title":"TypeClass.where/1","type":"macro"},{"doc":"Helpers for setting type class dependencies","ref":"TypeClass.Dependency.html","title":"TypeClass.Dependency","type":"module"},{"doc":"Set a type class dependency. ie: another type class that need to be definst ed before this one. Examples defmodule Quux do extend Foo extend Bar extend Baz # ... end","ref":"TypeClass.Dependency.html#extend/1","title":"TypeClass.Dependency.extend/1","type":"macro"},{"doc":"","ref":"TypeClass.Dependency.html#extend/2","title":"TypeClass.Dependency.extend/2","type":"macro"},{"doc":"The opposite of set_up/1 : collect dependencies","ref":"TypeClass.Dependency.html#run/0","title":"TypeClass.Dependency.run/0","type":"macro"},{"doc":"Set up the dependency collection from extend","ref":"TypeClass.Dependency.html#set_up/0","title":"TypeClass.Dependency.set_up/0","type":"macro"},{"doc":"","ref":"TypeClass.Dependency.html#t:ast/0","title":"TypeClass.Dependency.ast/0","type":"type"},{"doc":"A very simple prop checker","ref":"TypeClass.Property.html","title":"TypeClass.Property","type":"module"},{"doc":"Ensure that the type class has defined properties","ref":"TypeClass.Property.html#ensure!/0","title":"TypeClass.Property.ensure!/0","type":"macro"},{"doc":"Check for equality while handling special cases that normally don't equate in Elixir. For example, only check float accuracy to 5 decimal places due to internal rounding mismatches from applying functions in differing order. This isn't totally theoretically accurate, but is in line with the spirit of Floats.","ref":"TypeClass.Property.html#equal?/2","title":"TypeClass.Property.equal?/2","type":"function"},{"doc":"Run all properties for the type class","ref":"TypeClass.Property.html#run!/4","title":"TypeClass.Property.run!/4","type":"function"},{"doc":"Data generator protocol for property checks. The more variation the better.","ref":"TypeClass.Property.Generator.html","title":"TypeClass.Property.Generator","type":"protocol"},{"doc":"Generate a random example of datatype. Examples defimpl TypeClass.Property.Generator , for : Integer do def generate ( _ ) , do : :rand . uniform ( 1000 ) * Enum . random ( [ 1 , 1 , 1 , - 1 ] ) end defimpl TypeClass.Property.Generator , for : BitString do def generate ( _ ) do Stream . unfold ( &quot;&quot; , &amp; ( { &amp;1 , :rand . uniform ( 90 ) } ) ) |&gt; Stream . drop ( 1 ) |&gt; Stream . take ( :rand . uniform ( 4 ) ) |&gt; Enum . to_list ( ) |&gt; List . to_string ( ) end end","ref":"TypeClass.Property.Generator.html#generate/1","title":"TypeClass.Property.Generator.generate/1","type":"function"},{"doc":"","ref":"TypeClass.Property.Generator.html#t:t/0","title":"TypeClass.Property.Generator.t/0","type":"type"},{"doc":"Internal representation of a custom generator","ref":"TypeClass.Property.Generator.Custom.html","title":"TypeClass.Property.Generator.Custom","type":"module"},{"doc":"Define a hidden __cutsom_generator__/1 function","ref":"TypeClass.Property.Generator.Custom.html#custom_generator/2","title":"TypeClass.Property.Generator.Custom.custom_generator/2","type":"macro"},{"doc":"","ref":"TypeClass.Property.Generator.Custom.html#t:t/0","title":"TypeClass.Property.Generator.Custom.t/0","type":"type"},{"doc":"Helpers to module attributes","ref":"TypeClass.Utility.Attribute.html","title":"TypeClass.Utility.Attribute","type":"module"},{"doc":"Retrieve the compile-time value stored at the specified attribute key","ref":"TypeClass.Utility.Attribute.html#get/1","title":"TypeClass.Utility.Attribute.get/1","type":"macro"},{"doc":"Set up a compile time attribute key for getting and setting","ref":"TypeClass.Utility.Attribute.html#register/2","title":"TypeClass.Utility.Attribute.register/2","type":"macro"},{"doc":"Set a compile-time module attribute","ref":"TypeClass.Utility.Attribute.html#set/2","title":"TypeClass.Utility.Attribute.set/2","type":"macro"},{"doc":"Naming convention helpers to help follow TypeClass conventions","ref":"TypeClass.Utility.Module.html","title":"TypeClass.Utility.Module","type":"module"},{"doc":"","ref":"TypeClass.Utility.Module.html#get_functions/1","title":"TypeClass.Utility.Module.get_functions/1","type":"function"},{"doc":"Generate the module name for the protocol portion of the class. Does not nest Protocol s. Examples iex&gt; to_property MyClass.Awesome MyClass.Awesome.Property iex&gt; to_property MyClass.Awesome.Property MyClass.Awesome . roperty","ref":"TypeClass.Utility.Module.html#to_property/1","title":"TypeClass.Utility.Module.to_property/1","type":"function"},{"doc":"Generate the module name for the protocol portion of the class. Does not nest Protocol s. Examples iex&gt; to_protocol MyClass.Awesome MyClass.Awesome.Protocol iex&gt; to_protocol MyClass.Awesome.Protocol MyClass.Awesome.Protocol","ref":"TypeClass.Utility.Module.html#to_protocol/1","title":"TypeClass.Utility.Module.to_protocol/1","type":"function"},{"doc":"Generate a submodule name. If the module already ends in the requested submodule, it will return the module name unchanged. Examples iex&gt; MyModule.Awesome |&gt; to_submodule ( Submodule ) MyModule.Awesome.Submodule iex&gt; MyModule.Awesome |&gt; to_submodule ( &quot;Submodule&quot; ) MyModule.Awesome.Submodule iex&gt; MyModule.Awesome.Submodule |&gt; to_submodule ( Submodule ) MyModule.Awesome.Submodule","ref":"TypeClass.Utility.Module.html#to_submodule/2","title":"TypeClass.Utility.Module.to_submodule/2","type":"function"},{"doc":"","ref":"TypeClass.Utility.Module.html#t:ast/0","title":"TypeClass.Utility.Module.ast/0","type":"type"},{"doc":"Information about a failed property check Examples % TypeClass.Property.FailedCheckError { message : &quot;List does not conform to property CoolClass.associative&quot; , datatype : List , property : :associative , class : CoolClass }","ref":"TypeClass.Property.FailedCheckError.html","title":"TypeClass.Property.FailedCheckError","type":"exception"},{"doc":"Convenience constructor Examples iex&gt; TypeClass.Property.FailedCheckError . new ( List , CoolClass , :associative ) % TypeClass.Property.FailedCheckError { message : &quot;List does not conform to property CoolClass.associative&quot; , datatype : List , property : :associative , class : CoolClass }","ref":"TypeClass.Property.FailedCheckError.html#new/3","title":"TypeClass.Property.FailedCheckError.new/3","type":"function"},{"doc":"","ref":"TypeClass.Property.FailedCheckError.html#t:t/0","title":"TypeClass.Property.FailedCheckError.t/0","type":"type"},{"doc":"Warning if a type class is missing properties. Properties are required for all type classes.","ref":"TypeClass.Property.UndefinedError.html","title":"TypeClass.Property.UndefinedError","type":"exception"},{"doc":"Convenience constructor Examples iex&gt; TypeClass.Property.UndefinedError . new ( CoolClass ) % TypeClass.Property.UndefinedError { type_class : CoolClass , message : ~S&quot; CoolClass has not defined any properties, but they are required. See `TypeClass.properties/1` for more &quot; }","ref":"TypeClass.Property.UndefinedError.html#new/1","title":"TypeClass.Property.UndefinedError.new/1","type":"function"},{"doc":"","ref":"TypeClass.Property.UndefinedError.html#t:t/0","title":"TypeClass.Property.UndefinedError.t/0","type":"type"},{"doc":"TypeClass brings (semi-) principled type classes to Elixir README","ref":"readme.html","title":"README","type":"extras"},{"doc":"Quick Start Type Classes Condensed Style Hierarchical Principled Escape Hatches Example TypeClass Haskell","ref":"readme.html#table-of-contents","title":"README - Table of Contents","type":"extras"},{"doc":"def deps do [ { :type_class , &quot;~&gt; 1.1&quot; } ] end","ref":"readme.html#quick-start","title":"README - Quick Start","type":"extras"},{"doc":"Type classes are not unlike protocols. They are essentially a mechanism for ad hoc polymorphism. However, doing extensive work with protocols can be cumbersome in Elixir. Even the standard library uses the Enumerable protocol to support the Enum module. TypeClass attempts to hide many of the details to give you a single module interface. Condensed Style To this end, TypeClass provides the defclass/2 macro to handle generating all of the modules, submodules, and protocols. definst/3 (and definst/2 ) is very similar to defimpl/3 , except that you don't need to pass it the actual protocol; you only pass it just the &quot;top&quot; class module. It will also automatically run a number of checks at compile time to help keep everything running as per the definition in defclass/2 (more on that later). Hierarchical Type classes can be hierarchical. The extend/2 macro allows defining another class that your class depends on existing. A common and similar example from Haskell is how the monad instance must also be an applicative, which in turn must be a functor. definst/3 will check that the type you are implementing already has an implementation of the parent classes. Specifying multiple parents is totally okay, as this is superclassing, not subclassing like in an object oriented system. Principled Type classes have the ability to be abused. For instance, in languages such as Haskell, a programmer can define an instance of Monad a that is not actually a monad. This can lead to confusing and unexpected behaviour. After all the purpose of protocols and type classes is so that we abstract some invariant behaviour over many data types. At the core, type classes are about the properties that enable its functions to work correctly. To emphasize that: properties are the most important part of a type class . Strictly speaking, for the compiler to enforce properties at compile time, it needs to have a lot of type-level information (ideally dependent types, GADTs, or very advanced static analysis). Elixir is dynamically typed, and has almost no type information at compile time. TypeClass meets this challenge halfway: property testing. definst/3 will property test a small batch of examples on every data type that the class is defined for at compile time . By default, it skips this check in production, runs a minimal set of cases in development, and runs a larger suite in the test environment. Property testing lets TypeClass check hundreds of specific examples very quickly, so while it doesn't give you a guarantee that your instance is correct, it does give you a high level of confidence. John De Goes defines principled type classes as: Haskell-style. A baked-in notion of type classes in the overall style of Haskell, Purescript, Idris, etc. defclass/2 and definst/3 get us 99% of the way here. It's not as lightweight as in Haskell &amp;c, but it's close (and much more succinct than what is available in Kernel ). Lawful. First-class laws for type classes, which are enforced by the compiler. As mentioned above, we meet laws/properties halfway with compile-time property tests. Hierarchical. A compiler-verified requirement that a subclass of a type class must have at least one more law than that type class. TypeClass requires at least one property per class. You can build type class hierarchies with extend/2 . Globally Unambiguous. Type class resolution that produces an error if there exists more than one instances which satisfies the constraints at the point where the compiler must choose an instance. Elixir is dynamically typed, and so we cannot constrain functions at compile time. However, the point is well taken: rather than creating a renamed variant of a type so that you can have multiple instances (ex. Monoid can be integer addition or multiplication), extend the TypeClass and give it the additional properties that you're interested in for each case (ex. AdditiveMonoid and MultiplicativeMonoid extend Monoid ). Abstractable. The ability to abstract over type classes themselves. De Goes is referring here to abstracting over typed holes. Elixir is dynamically typed, so this one doesn't apply to us.","ref":"readme.html#type-classes","title":"README - Type Classes","type":"extras"},{"doc":"In the cases that you really need to override the prop checker, you have two options: @force_type_class true This will force the prop checker to pass for all data types for the class. This is generally a bad idea (see section on principled classes above), but may be nessesary for some extreme edge cases. Using this option will trigger a compile time warning. See defclass/2 on how to use. @force_type_instance true This will force the prop checker to pass for a particular instance. This is sometimes needed, since TypeClass's property checker may not be able to accurately validate all data types correctly for all possible cases, especially when only subsets of built-in types are valid. (For example, a class that can only be deifned on 2-tuples). Forcing a type instance in this way is like telling the checker &quot;trust me this is correct&quot;, and should only be used as a last resort. If at all possible, try to use custom_generator/2 first. Using this option will trigger a compile time warning. See definst/3 on how to use. custom_generator/2 If you need to specify a certain type of data that conforms to the type class, you can specify it with custom_generator/2 inside of the definst/3 . For example, Tuples should only have instances for 2-tuples for certain classes, so we can restrict the prop test data to 2-tuples rather than n-tuples. The generator must conform to the standard unary generator format. definst AwesomeClass , for : Tuple do custom_generator ( a ) do { :always_two , a } end # the rest as normal def awesome_level ( _ ) , do : 9000 end","ref":"readme.html#escape-hatches","title":"README - Escape Hatches","type":"extras"},{"doc":"TypeClass defclass Algebra.Monoid do extend Algebra.Semigroup where do def empty ( sample ) end properties do def left_identity ( data ) do a = generate ( data ) Semigroup . concat ( Monoid . empty ( a ) , a ) == a end def right_identity ( data ) do a = generate ( data ) Semigroup . concat ( a , Monoid . empty ( a ) ) == a end end end Haskell The rough equivalent in Haskell module Algebra.Monoid where class (Setoid a, Semigroup a) =&gt; Monoid a where identity :: a -&gt; a -- Not actually needed in this case -- Just here to illustrate including functions for minimal definitions append_id :: a -&gt; a append_id a = identity a `append` a instance Monoid [a] where identity _ = []","ref":"readme.html#example","title":"README - Example","type":"extras"}]